com.unitech.lib.params

## Class DeviceParam

- java.lang.Object
- - com.unitech.lib.params.BaseParam
  - - com.unitech.lib.params.DeviceParam

-     public class DeviceParam
      extends BaseParam

  The DeviceParam class represents a device parameter. It provides methods to get and set the parameter value.

- - ### Field Summary

    - ### Fields inherited from class com.unitech.lib.params.BaseParam

      `_default, _max, _maxVersion, _min, _minVersion, _options, _value, type`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DeviceParam(DeviceParamID id)` Initializes a new instance of the DeviceParam class with the specified parameter ID.
    `DeviceParam(DeviceParamID id, Object defaultValue)` Initializes a new instance of the DeviceParam class with the specified parameter ID and default value.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Object` | `getDefaultValue()` Get the default value of the parameter
    `DeviceParamID` | `getId()` Gets the ID of the parameter.
    `Object[]` | `getOptions()` Get the options of the parameter
    `byte[]` | `getRawValue()` Get the value with raw byte array format
    `Object` | `getValue()` Get the value of the parameter
    `void` | `setCurrentValue(Object value)` Set the value of the parameter without checking the access mode.
    `void` | `setRawValue(String value)`
    `void` | `setValue(Object value)` Set the value of the parameter
    `DeviceParam` | `toDeviceParam()` In child classes, this method is override to return a DeviceParam.

    - ### Methods inherited from class com.unitech.lib.params.BaseParam

      `getMaxVersion, getMinVersion, toEngineParam`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DeviceParam

          public DeviceParam(DeviceParamID id)

      Initializes a new instance of the DeviceParam class with the specified parameter ID.
      Parameters:
        `id` - The DeviceParamID enumeration that indicates the parameter ID.

    - #### DeviceParam

          public DeviceParam(DeviceParamID id,
                             Object defaultValue)

      Initializes a new instance of the DeviceParam class with the specified parameter ID and default value.
      Parameters:
        `id` - The DeviceParamID enumeration that indicates the parameter ID.
        `defaultValue` - The default value of the parameter.

  - ### Method Detail

    - #### getId

          public DeviceParamID getId()

      Gets the ID of the parameter.
      Returns:
        The ID of the parameter.

    - #### toDeviceParam

          public DeviceParam toDeviceParam()

      Description copied from class: `BaseParam`
      In child classes, this method is override to return a DeviceParam.
      Overrides:
        `toDeviceParam` in class `BaseParam`
      Returns:
        A DeviceParam object representing the current BaseParam.

    - #### getValue

          public Object getValue()

      Get the value of the parameter
      Returns:
        The value of the parameter

    - #### setValue

          public void setValue(Object value)

      Set the value of the parameter
      Parameters:
        `value` - The value to set

    - #### getDefaultValue

          public Object getDefaultValue()

      Get the default value of the parameter
      Returns:
        The default value of the parameter

    - #### getOptions

          public Object[] getOptions()

      Get the options of the parameter
      Returns:
        The options of the parameter

    - #### setCurrentValue

          public void setCurrentValue(Object value)

      Set the value of the parameter without checking the access mode.
      Parameters:
        `value` - The value to set

    - #### setRawValue

          public void setRawValue(String value)

    - #### getRawValue

          public byte[] getRawValue()

      Get the value with raw byte array format
      Returns:
        The raw byte array format of the value